Imports System.Drawing

Public Class PFMain
    Inherits System.Windows.Forms.Form

#Region "Variables"
    Dim GFX As Graphics  'Draws to the backbuffer.
    Dim FormGFX As Graphics  ' Draws to the form.

    Dim Backbuffer As Bitmap    'Empty bitmap.

    Dim PlayerBmp As Bitmap           'This will hold the main character graphics.
    'Actually, it is a bunch of frames of the character.

    Dim PlayerLoc As Rectangle
    'This will hold the current location of the player.  X and Y included.
    'Why didn't I use point?  Because I am probably going to use the height and width for collisions later.
    Dim GoLeft, GoRight, GoFast As Boolean
    'Indicates which buttons are pressed.
    Dim CharDirec As Integer
    'Which direction is the character facing?
    Dim AnimCycler As Integer
    'This is the animation cycler that will count from 0 to 3 and back to 0.
    Dim IsJumping As Boolean
    'While this is true, the character will be jumping.
    Dim PlayerVeloc As Integer
    'This is the velocity of the player in the Y direction.
    'Positive values point down.
    'To jump up, PlayerVeloc must be initialized to a negative value.
    Dim GoDown As Boolean
    'Indicates if the down arrow is pressed.
    Dim Platform As Rectangle
    'A platform.
    Dim LeftEnd As Integer
    Dim RightEnd As Integer
    'This stores the locations of the end of the cliff that the character is currently on.
    Dim Platforms As ArrayList
    'This will store the platforms that are in this level.
    Dim Coin As Rectangle
    'This holds the location of the coin.
    Dim CoinBmp As Bitmap
    'This contains the frames of the coin as it will be drawn onto the map.
    Dim Wall As Rectangle
    'Holds the location of the wall.
    Dim Coins As ArrayList
    'Holds all of the coin locations.
    Dim Walls As ArrayList
    'Stores the walls that are in this level.
    Dim IsMouseDown As Boolean
    'Indicates if the mouse button is pressed.
    Dim InitialPt, FinalPt As Point
    'Stores the mouse's locations for the rectangle setup.
    Dim MDObject As Char
    'Character is P, W, or C for platform, wall, or coin.
    Dim Lava As Rectangle
    'A deadly rectangle of lava that will kill the character.
    Dim LavaBrsh As Brush
    'This will be the brush that draws the lava onto the display.
    Dim IsGoner As Boolean
    'If this variable is true, then the player is dead.
    Dim FloatBmp As Bitmap
    'THe bitmap that will hold the picture of the floater.
    Dim Floater As LevFloater
    'This is the floater's location and movement information on the field.
    Dim FloatTick As Integer
    'This is the time variable that indicates what part of the periodic floater function.
    Dim Lavas As ArrayList
    'Holds all of the lava pools for this level.
    Dim Floaters As ArrayList
    'Holds all of the floaters for this level.

#End Region

#Region "Constants"
    Const MAPWIDTH As Integer = 800
    Const MAPHEIGHT As Integer = 600
    'I need to determine a default spot for my land.
    'It has to be between 0 and MAPHEIGHT, since that's the height of my backbuffer.
    'Preferably closer to 600 as more land equals less playing area.
    Const LANDHEIGHT As Integer = 568
    '600 - 32 = 568... I like 32. 
    'Constants are good for you.
    Const CHARWIDTH As Integer = 16
    Const CHARHEIGHT As Integer = 32
    'These define the width of the character in the file.

    Const MOVESPEED As Integer = 5
    'How much I move every tick
    Const WALKINGFRAMECOUNT As Integer = 4
    'How many frames are in each walking cycle.
    Const SBARINITIALVELOCITY As Integer = -32
    'The initial velocity for the player's jump using space bar.
    Const GRAVITY As Integer = 4
    'Gravitational acceleration constant... how much the speed changes at each tick.
    Const LOWJUMPVELOCITY As Integer = -20
    'Initial velocity for a low jump.
    Const SHOULDER As Integer = 17
    'Looked in paint to determine the distance the shoulder is from the bottom of the foot.
    'This will be used for determining if the player gets on a platform.
    Const COINSIZE As Integer = 16
    'The width and height of the coin.
    Const COINFRAMECOUNT As Integer = 4
    'The number of frames in the coin bitmap.
    Const SPINOUTSPEED As Single = 50.0F
    'How fast the character spins when he has been killed.
    Const DOOMTIMEOUT As Integer = 15
    'Wait this many frames until the character begins tumbling to the bottom of the screen.
    Const FLOATERSIZE As Integer = 16
    'The width and height of floater.
    Const FREQUENCYDIVIDER As Integer = 128
    'The number that will divide the frequency of periodic functions.
    Const GRAVITYTH As Integer = GRAVITY * 3 >> 1
    'This represents how much the player moved due to gravity.

#End Region

#Const TESTversion = 0
    'Set this to 1 to allow the testing / editing / debug version of the game.

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents Clock As System.Windows.Forms.Timer
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Me.Clock = New System.Windows.Forms.Timer(Me.components)
        '
        'Clock
        '
        Me.Clock.Enabled = True
        '
        'PFMain
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(520, 381)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
        Me.MaximizeBox = False
        Me.Name = "PFMain"
        Me.Text = "Platform Tour"

    End Sub

#End Region

    Private Sub PFMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Setup our clock interval.
        Clock.Interval = 50
        Clock.Enabled = True

        Me.Size = New Size(MAPWIDTH + 8, MAPHEIGHT + 24)

        'Create the backbuffer.  This will hold the map information... what you actually will see, because I
        'am going to draw it to the form in one fell swoop.  Just that I'm going to be drawing onto the backbuffer
        'for all of my miscellaneous artworks, and then draw everything that I accumulated onto this backbuffer to the
        'form. :)
        Backbuffer = New Bitmap(MAPWIDTH, MAPHEIGHT)
        'GFX is aimed at the backbuffer.
        GFX = Graphics.FromImage(Backbuffer)
        'FormGFX is aimed at the form.
        FormGFX = Me.CreateGraphics()

        LeftEnd = 0 : RightEnd = MAPWIDTH
        'Set the current end points.

        MDObject = "P"c
        'Initialize to P for platforms so that mousedown produces platforms at the beginning.


        CoinBmp = New Bitmap(Application.StartupPath & "\..\coin.bmp")
        'Initialize the coin location and picture.
        CoinBmp.MakeTransparent(Color.Magenta)
        'Clears the magenta colors in this bitmap.

        LoadLevel(Application.StartupPath & "\testone.dat")
        'Loads the information for this level.


        LavaBrsh = New SolidBrush(Color.FromArgb(192, 255, 32, 32))
        'Translucent hot looking red brush color.

        FloatBmp = New Bitmap(Application.StartupPath & "\..\iorb.gif")
        'Picture of the floater.
        FloatTick = 0
        'Init the float counter.



        PlayerBmp = New Bitmap(Application.StartupPath & "\..\sumult.bmp")
        'Loads the image into this bitmap.
        'Given this arrangement, the bitmap must be in the same directory as the solution.
        PlayerBmp.MakeTransparent(Color.Magenta)
        'Makes all of the magenta in the bitmap transparent.

        PlayerLoc = New Rectangle(100, LANDHEIGHT - CHARHEIGHT, CHARWIDTH, CHARHEIGHT)
        'Instantiate the player location.
    End Sub

    Private Sub Clock_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Clock.Tick

        Me.CharacterMovement()
        'Handles the character movement.
        Me.Artwork()
        'Draws the information to the backbuffer, and then, to the form.

    End Sub

    Private Sub DrawOnForm()
        FormGFX.DrawImage(Backbuffer, 0, 0)
        'The backbuffer was drawn on by the GFX.
    End Sub

    Private Sub PFMain_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyDown
        If e.KeyCode = Keys.Left Then
            GoLeft = True
        ElseIf e.KeyCode = Keys.Right Then
            GoRight = True
        ElseIf e.KeyCode = Keys.ShiftKey Then
            GoFast = True
        ElseIf e.KeyCode = Keys.Down Then
            GoDown = True
        ElseIf e.KeyCode = Keys.Space Then
            If Not IsJumping Then
                IsJumping = True
                'The jump is initialized.
                If GoDown Then
                    PlayerVeloc = Me.LOWJUMPVELOCITY
                    'Use low jump velocity if down is pressed.
                Else
                    PlayerVeloc = Me.SBARINITIALVELOCITY
                    'Use space bar initial velocity.

                End If
            End If

#If TESTversion = 1 Then  'This code will be hidden from the compiler when TESTversion is set to 0.
        ElseIf e.KeyCode = Keys.S AndAlso e.Control Then
            SaveLevel()
        ElseIf e.KeyCode = Keys.P Then
            If Not IsMouseDown Then
                MDObject = "P"c
            End If
        ElseIf e.KeyCode = Keys.W Then
            If Not IsMouseDown Then
                MDObject = "W"c
            End If
        ElseIf e.KeyCode = Keys.C Then
            If Not IsMouseDown Then
                MDObject = "C"c
            End If
        ElseIf e.KeyCode = Keys.L Then
            If Not IsMouseDown Then
                MDObject = "L"c
            End If

        ElseIf e.KeyCode = Keys.F Then
            If Not IsMouseDown Then
                MDObject = "F"c
            End If


#End If  'The following code will be visible.  Anything between the #If and #End If will be gone when TESTversion is 0.

        End If
    End Sub

    Private Sub PFMain_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyUp
        If e.KeyCode = Keys.Left Then
            GoLeft = False
        ElseIf e.KeyCode = Keys.Right Then
            GoRight = False
        ElseIf e.KeyCode = Keys.ShiftKey Then
            GoFast = False
        ElseIf e.KeyCode = Keys.Down Then
            GoDown = False
        End If

        If Not (GoLeft OrElse GoRight) Then
            'If neither key is pressed.
            AnimCycler = 0
            'Reset the counter, and signal another redraw.
        End If

    End Sub

    Private Sub CharacterMovement()
        Dim dX, dY As Integer
        'Indicates how much an object moves during this frame.

        If Not IsGoner Then
            'Do this only if the player has not been killed.

            If GoLeft Then
                If GoFast Then
                    PlayerLoc.Offset(-MOVESPEED - (MOVESPEED >> 1), 0)
                    'When Shift is pressed the player runs.
                    'Runs to the left.
                Else
                    PlayerLoc.Offset(-MOVESPEED, 0)
                    'Move player left.

                End If
                If PlayerLoc.Left < 0 Then
                    'If the player goes off the edge of the form, then we will move him back to the edge.
                    PlayerLoc.Offset(-PlayerLoc.Left, 0)
                ElseIf PlayerLoc.Right < LeftEnd AndAlso Not IsJumping Then
                    IsJumping = True
                    'We are not really jumping, but we are falling.
                    PlayerVeloc = 0
                    'Since we are falling from rest, the initial velocity will be zero.
                Else
                    For Each Wall In Walls
                        'Check with each wall.
                        If PlayerLoc.IntersectsWith(Wall) Then
                            PlayerLoc.Offset(Wall.Right - PlayerLoc.Left, 0)
                            'Move the player to the edge of this wall.
                        End If
                    Next
                End If
                CharDirec = 0   'Look left.
                'Now, update the animation cycler.
                AnimCycler = (AnimCycler + 1) Mod WALKINGFRAMECOUNT
            ElseIf GoRight Then
                If GoFast Then
                    PlayerLoc.Offset(MOVESPEED + (MOVESPEED >> 1), 0)
                    'Runs to the right.
                Else
                    PlayerLoc.Offset(MOVESPEED, 0)
                    'Move player right.

                End If
                If PlayerLoc.Right > MAPWIDTH Then
                    'If player goes off right edge... move him back.
                    PlayerLoc.Offset(MAPWIDTH - PlayerLoc.Right, 0)
                ElseIf PlayerLoc.Left > RightEnd AndAlso Not IsJumping Then
                    IsJumping = True
                    'We are falling.
                    PlayerVeloc = 0
                    'A fall from rest.
                Else
                    For Each Wall In Walls
                        If PlayerLoc.IntersectsWith(Wall) Then
                            PlayerLoc.Offset(Wall.Left - PlayerLoc.Right, 0)
                            'Move the player to the edge of this wall.

                        End If
                    Next

                End If
                CharDirec = 1   'Look right.
                'Now, update the animation cycler.
                AnimCycler = (AnimCycler + 1) Mod WALKINGFRAMECOUNT
            End If



            If IsJumping Then
                PlayerLoc.Offset(0, PlayerVeloc + GRAVITY >> 1)
                'dD (.OffSet) = Vo (PlayerVeloc) + 0.5 * A (GRAVITY >> 1)
                PlayerVeloc += GRAVITY
                'dV = (PlayerVeloc +=) A (GRAVITY)
                'Moves the character according to its velocity, gravity, and location.
                If PlayerLoc.Bottom >= Me.LANDHEIGHT Then
                    'Check if we are touching the ground (another RECT advantage).

                    IsJumping = False
                    'Stop the jump: we have hit the ground.
                    LeftEnd = 0 : RightEnd = MAPWIDTH
                    'Set the endpoints for the ground.
                    AnimCycler = 0
                    'Reset the animation cycler: it has been counting during the jump.
                    PlayerLoc.Offset(0, LANDHEIGHT - PlayerLoc.Bottom)
                    'Move the player to stand on the land properly.
                Else

                    For Each Platform In Platforms
                        'Looking at each platform in the platform array.
                        If PlayerVeloc > 0 AndAlso PlayerLoc.Bottom >= Platform.Top AndAlso PlayerLoc.Bottom - PlayerVeloc - GRAVITYTH <= Platform.Top Then
                            If PlayerLoc.Left < Platform.Right AndAlso PlayerLoc.Right > Platform.Left Then
                                'The player has landed on this platform.  He needs to be updated.
                                'See how many advantages there are to using a Rectangle.

                                IsJumping = False
                                'Hit the ground, we are not jumping.
                                LeftEnd = Platform.Left : RightEnd = Platform.Right
                                'Set the endpoints for the platform.
                                AnimCycler = 0
                                'Reset cycler.
                                PlayerLoc.Offset(0, Platform.Top - PlayerLoc.Bottom)
                                'Move the player onto this platform.
                            End If
                        End If
                    Next

                    For Each Wall In Walls
                        If PlayerLoc.IntersectsWith(Wall) Then
                            If IsJumping = False Then  'If the player has landed on a platform.
                                IsJumping = True
                                'Knock the player off the platform and make the player
                                PlayerLoc.Offset(0, Wall.Bottom - PlayerLoc.Top + GRAVITYTH)
                                'Move the player to under the wall.  We need GRAVITYTH so that the player climb up to the platform.
                                PlayerVeloc = 0
                                'Make the player start falling.

                            ElseIf PlayerVeloc > 0 Then
                                'If player is falling, then the player will land on the wall.
                                IsJumping = False
                                'Stop the jump.
                                LeftEnd = Wall.Left : RightEnd = Wall.Right
                                'Set the endpoints.
                                AnimCycler = 0
                                'Reset the cycler.
                                PlayerLoc.Offset(0, Wall.Top - PlayerLoc.Bottom)
                                'Position the player to stand on this wall.
                            Else
                                'The player has jumped up into the wall.
                                PlayerLoc.Offset(0, Wall.Bottom - PlayerLoc.Top)
                                'Move the player to under the wall.
                                PlayerVeloc = 0
                                'Make the player start falling down.
                            End If
                        End If
                    Next


                End If
            End If

#If TESTversion = 0 Then
            Dim LV As Integer
            For LV = 0 To Coins.Count - 1
                Coin = DirectCast(Coins(LV), Rectangle)
                If Coin.IntersectsWith(PlayerLoc) Then
                    Coin = Coin.Empty
                    'Make the coin rectangle empty to indicate that we do not need to draw it.
                    Coins(LV) = Coin
                End If
            Next
#End If

            For Each Lava In Lavas
                If Lava.IntersectsWith(PlayerLoc) Then
                    IsGoner = True
                    'The player steps into lava.  Lose a life.
                    PlayerVeloc = SBARINITIALVELOCITY
                End If
            Next

            For Each Floater In Floaters
                If Floater.Loc.IntersectsWith(PlayerLoc) Then
                    IsGoner = True
                    'The player has touched the floater.  Lose a life.
                    PlayerVeloc = SBARINITIALVELOCITY
                End If

            Next
            Me.Text = Floater.Loc.Width.ToString()
        End If

#If TESTversion = 0 Then

        Dim LP As Integer
        For LP = 0 To Floaters.Count - 1
            Floater = DirectCast(Floaters(LP), LevFloater)
            'Since we are changing properties of the floater, and since floater is a structure, we have to reassign the
            'newly modified floater back to the array.

            Select Case Floater.FunctionHorizontal
                'Looking at the function that we have designated, we choose the proper periodic function for setting to dX and dY.
                Case PeriodicDesignation.CosineFxn
                    dX = Convert.ToInt32(Floater.RadispeedX * Math.Cos(Convert.ToDouble(FloatTick) * Floater.FrequencyX / Me.FREQUENCYDIVIDER))
                Case PeriodicDesignation.SineFxn
                    dX = Convert.ToInt32(Floater.RadispeedX * Math.Sin(Convert.ToDouble(FloatTick) * Floater.FrequencyX / Me.FREQUENCYDIVIDER))
                Case PeriodicDesignation.Stable
                    dX = 0
            End Select
            Select Case Floater.FunctionVertical
                'Looking at the function that we have designated, we choose the proper periodic function for setting to dX and dY.
                Case PeriodicDesignation.CosineFxn
                    dY = Convert.ToInt32(Floater.RadispeedY * Math.Cos(Convert.ToDouble(FloatTick) * Floater.FrequencyY / Me.FREQUENCYDIVIDER))
                Case PeriodicDesignation.SineFxn
                    dY = Convert.ToInt32(Floater.RadispeedY * Math.Sin(Convert.ToDouble(FloatTick) * Floater.FrequencyY / Me.FREQUENCYDIVIDER))
                Case PeriodicDesignation.Stable
                    dY = 0
            End Select

            Floater.Offset(dX, dY)
            'Move the floater using our offset subroutine.
            Floaters(LP) = Floater
            'Return the floater that we've modified to the array.
        Next

#End If


        FloatTick += 1

    End Sub

    Private Sub Artwork()
        Static Anim As Integer
        'Holds a number that coordinates animations.

        Static RotateAngle As Single
        'Holds the current rotation angle for our character.

        Static Doompause As Integer
        'After this hits a certain value, the character will begin tumbling because he has been killed.

        Anim += 1
        'Increment the counter.

        'I am going to draw a lightblue rectangle for the sky.
        'It will go down until it reaches the land, so therefore the bottom of the rectangle has to be
        'the LANDHEIGHT.
        GFX.FillRectangle(Brushes.LightSkyBlue, Rectangle.FromLTRB(0, 0, MAPWIDTH, LANDHEIGHT))
        'And the remainder of the area is LAND, starting from LANDHEIGHT.
        GFX.FillRectangle(Brushes.ForestGreen, Rectangle.FromLTRB(0, LANDHEIGHT, MAPWIDTH, MAPHEIGHT))
        'I use LTRB instead of New so that I don't have to calculate the height.
        'These two will make the 'background' for the form.
        For Each Platform In Platforms
            'Loop through each platform in the arraylist.
            GFX.FillRectangle(Brushes.Tan, Platform)
            GFX.DrawRectangle(Pens.RosyBrown, Platform)
            'I'm not into interior decorating, so the only thing I can say about these colors is that 
            'they'd better be a light brown persuasion.  This draws the platform.
        Next
        For Each Wall In Walls
            GFX.FillRectangle(Brushes.Chocolate, Wall)
            GFX.DrawRectangle(Pens.BurlyWood, Wall)
            'This will draw the wall onto the form.
        Next





        If IsGoner Then

            If Doompause >= DOOMTIMEOUT Then
                GFX.TranslateTransform(Convert.ToSingle(PlayerLoc.X) + (Me.CHARWIDTH >> 1), Convert.ToSingle(PlayerLoc.Y) + (Me.CHARWIDTH >> 1))
                'Move the center point to the center of the character's midpoint.
                GFX.RotateTransform(RotateAngle)
                'Spin the character clockwise.
                RotateAngle += SPINOUTSPEED

                If IsJumping Then
                    GFX.DrawImage(PlayerBmp, -Me.CHARWIDTH >> 1, -Me.CHARHEIGHT >> 1, New Rectangle((CHARWIDTH * WALKINGFRAMECOUNT << 1) + CharDirec * CHARWIDTH, 0, CHARWIDTH, CHARHEIGHT), GraphicsUnit.Pixel)
                    'Draw the character centered on the point 0, 0
                Else
                    GFX.DrawImage(PlayerBmp, -Me.CHARWIDTH >> 1, -Me.CHARHEIGHT >> 1, New Rectangle(CHARWIDTH * CharDirec * WALKINGFRAMECOUNT + AnimCycler * CHARWIDTH, 0, CHARWIDTH, CHARHEIGHT), GraphicsUnit.Pixel)
                    'This draws the character to the display, based on the current character location, frame, and state.
                End If

                PlayerLoc.Offset(0, PlayerVeloc + GRAVITY >> 1)
                'Gravity-based calculations that we have already done in CharacterMovement.
                PlayerVeloc += GRAVITY

                GFX.ResetTransform()
            Else

                RotateAngle = 0.0F
                'Reset the rotateangle for our tumbling-spinning character.

                Doompause += 1
                'Increment the delay counter.
                If IsJumping Then
                    GFX.DrawImage(PlayerBmp, PlayerLoc.X, PlayerLoc.Y, New Rectangle((CHARWIDTH * WALKINGFRAMECOUNT << 1) + CharDirec * CHARWIDTH, 0, CHARWIDTH, CHARHEIGHT), GraphicsUnit.Pixel)
                    'Jumping draw only.
                Else
                    GFX.DrawImage(PlayerBmp, PlayerLoc.X, PlayerLoc.Y, New Rectangle(CHARWIDTH * CharDirec * WALKINGFRAMECOUNT + AnimCycler * CHARWIDTH, 0, CHARWIDTH, CHARHEIGHT), GraphicsUnit.Pixel)
                    'This draws the character to the display, based on the current character location, frame, and state.
                End If

            End If

        Else
            If IsJumping Then
                GFX.DrawImage(PlayerBmp, PlayerLoc.X, PlayerLoc.Y, New Rectangle((CHARWIDTH * WALKINGFRAMECOUNT << 1) + CharDirec * CHARWIDTH, 0, CHARWIDTH, CHARHEIGHT), GraphicsUnit.Pixel)
                'Jumping draw only.
            Else
                GFX.DrawImage(PlayerBmp, PlayerLoc.X, PlayerLoc.Y, New Rectangle(CHARWIDTH * CharDirec * WALKINGFRAMECOUNT + AnimCycler * CHARWIDTH, 0, CHARWIDTH, CHARHEIGHT), GraphicsUnit.Pixel)
                'This draws the character to the display, based on the current character location, frame, and state.
            End If

        End If

        For Each Coin In Coins
            If Not Coin.IsEmpty Then
                GFX.DrawImage(CoinBmp, Coin.X, Coin.Y, New Rectangle((Anim Mod COINFRAMECOUNT) * COINSIZE, 0, COINSIZE, COINSIZE), GraphicsUnit.Pixel)
                'Draws our spinning coin onto the form.
            End If
        Next

        For Each Lava In Lavas
            GFX.FillRectangle(LavaBrsh, Lava)
            GFX.DrawRectangle(Pens.Red, Lava)
            'The translucent lava will be drawn with a red box around the border.
        Next

        For Each Floater In Floaters
            GFX.DrawImage(FloatBmp, Floater.Loc.X, Floater.Loc.Y)
            'Draw the floater to the display.  There's only one frame, so no selection involved.
        Next

        If IsMouseDown Then
            Dim Outline As Rectangle
            Dim Curse As Point
            Curse = Cursor.Position
            Curse = Me.PointToClient(Curse)
            'Create the cursor's point on the form.
            Outline = Rectangle.FromLTRB(Math.Min(InitialPt.X, Curse.X), Math.Min(InitialPt.Y, Curse.Y), _
                                         Math.Max(InitialPt.X, Curse.X), Math.Max(InitialPt.Y, Curse.Y))
            'Creates the drawing rectangle.  Now to draw it.
            GFX.DrawRectangle(Pens.Black, Outline)
        End If




        Me.DrawOnForm()
        'Me.Invalidate(New Rectangle(0, 0, 1, 1))
    End Sub

#If TESTversion = 1 Then

    Private Sub SaveLevel()
        'Before we run the rest of this sub, let's get a filename.
        Dim SFD As SaveFileDialog = New SaveFileDialog
        SFD.Filter = "Data Files|*.dat"
        SFD.InitialDirectory = Application.StartupPath
        SFD.OverwritePrompt = True
        SFD.Title = "Select the location where this level will be saved."
        If SFD.ShowDialog() = DialogResult.OK Then
            'First, let's create a binarywriter to write the information to the file.
            Dim FS As System.IO.FileStream = New System.IO.FileStream(SFD.FileName, IO.FileMode.Create)
            Dim BW As System.IO.BinaryWriter = New System.IO.BinaryWriter(FS)

            'First, the number of platforms is written to the file.
            BW.Write(Platforms.Count)
            'Next, each platform is written to file.
            For Each Platform In Platforms
                BW.Write(Platform.Left)
                BW.Write(Platform.Top)
                BW.Write(Platform.Right)
                BW.Write(Platform.Bottom)
            Next
            'Next, the number of walls is written to file.
            BW.Write(Walls.Count)
            'Then, each wall is written to file.
            For Each Wall In Walls
                BW.Write(Wall.Left)
                BW.Write(Wall.Top)
                BW.Write(Wall.Right)
                BW.Write(Wall.Bottom)
            Next
            'Then, the coins are written to file.
            BW.Write(Coins.Count)
            'Finally, each coin is written to file.
            For Each Coin In Coins
                BW.Write(Coin.Left)
                BW.Write(Coin.Top)
            Next
            'Next, lava is written to file
            BW.Write(Lavas.Count)
            'And then, each lava is written.
            For Each Lava In Lavas
                BW.Write(Lava.Left)
                BW.Write(Lava.Top)
                BW.Write(Lava.Right)
                BW.Write(Lava.Bottom)
            Next
            'Floaters are written to file.
            BW.Write(Floaters.Count)
            For Each Floater In Floaters
                BW.Write(Floater.Loc.Left)
                BW.Write(Floater.Loc.Top)
                BW.Write(Floater.RadispeedX)
                BW.Write(Floater.RadispeedY)
                BW.Write(Floater.FrequencyX)
                BW.Write(Floater.FrequencyY)
                BW.Write(Floater.FunctionHorizontal)
                BW.Write(Floater.FunctionVertical)
            Next
            'And we are done.
            'Close the file.
            BW.Close()
            FS.Close()

        End If

    End Sub

#End If

    Private Sub LoadLevel(ByVal Filename As String)
        'We need to create a binaryreader to read from the file.
        Dim FS As System.IO.FileStream = New System.IO.FileStream(Filename, IO.FileMode.Open)
        Dim BR As System.IO.BinaryReader = New System.IO.BinaryReader(FS)
        Dim LV As Integer 'Loop variable.

        Platforms = New ArrayList(BR.ReadInt32())
        For LV = 1 To Platforms.Capacity  'Capacity is the number that you've specified in the New arraylist's constructor.
            Platforms.Add(Rectangle.FromLTRB(BR.ReadInt32(), BR.ReadInt32(), BR.ReadInt32(), BR.ReadInt32()))
            'Read four integers from the file and put it into a rectangle.
        Next
        Platforms.Capacity = 100

        Walls = New ArrayList(BR.ReadInt32())
        For LV = 1 To Walls.Capacity
            Walls.Add(Rectangle.FromLTRB(BR.ReadInt32(), BR.ReadInt32(), BR.ReadInt32(), BR.ReadInt32()))
            'Same for four integers going into wall rectangles.
        Next
        Walls.Capacity = 100

        Coins = New ArrayList(BR.ReadInt32())
        For LV = 1 To Coins.Capacity
            Coins.Add(New Rectangle(BR.ReadInt32(), BR.ReadInt32(), COINSIZE, COINSIZE))
            'Coins only need left and top.  Their width and height are defined by coin size.
        Next
        Coins.Capacity = 100

        Lavas = New ArrayList(BR.ReadInt32())
        For LV = 1 To Lavas.Capacity
            Lavas.Add(Rectangle.FromLTRB(BR.ReadInt32(), BR.ReadInt32(), BR.ReadInt32(), BR.ReadInt32()))
            'Read the lavas into the file.
        Next

        Floaters = New ArrayList(BR.ReadInt32())
        For LV = 1 To Floaters.Capacity
            Floaters.Add(New LevFloater(Rectangle.FromLTRB(BR.ReadInt32(), BR.ReadInt32(), FLOATERSIZE, FLOATERSIZE), _
            BR.ReadInt32(), BR.ReadInt32(), BR.ReadInt32(), BR.ReadInt32(), _
            CType(BR.ReadInt32(), PeriodicDesignation), CType(BR.ReadInt32(), PeriodicDesignation)))
        Next
        Floaters.Capacity = 20

        'Close the files.
        BR.Close()
        FS.Close()

    End Sub

#If TESTversion = 1 Then

    Private Sub PFMain_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseDown
        IsMouseDown = True
        InitialPt = New Point(e.X, e.Y)
        'Set the initial point.
    End Sub

    Private Sub PFMain_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseUp
        Dim Placed As Rectangle
        'This is the rectangle that we have drawn.
        Dim Mu As Point = New Point(e.X, e.Y)
        'Convert the mouseeventargs's .X and .Y into a Point structure.
        IsMouseDown = False


        Select Case MDObject
            Case "P"c
                Placed = Rectangle.FromLTRB(Math.Min(InitialPt.X, Mu.X), Math.Min(InitialPt.Y, Mu.Y), Math.Max(InitialPt.X, Mu.X), Math.Max(InitialPt.Y, Mu.Y))
                Platforms.Insert(0, Placed)
                'Add a platform.
            Case "W"c
                Placed = Rectangle.FromLTRB(Math.Min(InitialPt.X, Mu.X), Math.Min(InitialPt.Y, Mu.Y), Math.Max(InitialPt.X, Mu.X), Math.Max(InitialPt.Y, Mu.Y))
                Walls.Insert(0, Placed)
                'Add a wall.
            Case "L"c
                Placed = Rectangle.FromLTRB(Math.Min(InitialPt.X, Mu.X), Math.Min(InitialPt.Y, Mu.Y), Math.Max(InitialPt.X, Mu.X), Math.Max(InitialPt.Y, Mu.Y))
                Lavas.Insert(0, Placed)
                'Add a wall.
            Case "C"c
                Coins.Insert(0, New Rectangle(Mu.X, Mu.Y, COINSIZE, COINSIZE))
                'Place a coin at the point where the mouse was released.
            Case "F"c
                Clock.Enabled = False
                'Lighten the processing load while we set up our floater.
                Dim Fm As FloaterEd = New FloaterEd
                Fm.ShowDialog()
                'After the showdialog, the floater's final six properties will be set.
                'But, the rectangle will be empty.
                Dim Fltr As LevFloater = Fm.Floater
                'Copy the floater to our variable.
                Fltr.Loc = New Rectangle(Mu.X, Mu.Y, FLOATERSIZE, FLOATERSIZE)
                'Set the rectangle.  The size is fixed, so we just make the rectangle like we did for the coin.
                Floaters.Insert(0, Fltr)
                'And this final floater will be added.
                'The movement of the floater after it is added to the form is not the exact movement that it will have
                'when it is loaded from file, because the value of FloatTick is not always 0 when the floater is created, and its
                'movement depends on the value of floattick with the periodic function.
                Clock.Enabled = True
                'Continue game.
        End Select
    End Sub

#End If
End Class

Public Enum PeriodicDesignation
    Stable = 0  'Denotes that the object will not move in this direction.
    CosineFxn   'Moves using the cosine function.
    SineFxn     'Moves using the sine function.
End Enum

Public Structure LevFloater
    Private rect As Rectangle
    Private horizfxn As PeriodicDesignation
    Private vertfxn As PeriodicDesignation
    Private xrspeed As Integer
    Private yrspeed As Integer
    Private xfreq As Integer
    Private yfreq As Integer

    Public Property Loc() As Rectangle
        Get
            Return rect
        End Get
        Set(ByVal Value As Rectangle)
            rect = Value
        End Set
    End Property
    Public Property FunctionHorizontal() As PeriodicDesignation
        Get
            Return horizfxn
        End Get
        Set(ByVal Value As PeriodicDesignation)
            horizfxn = Value
        End Set
    End Property
    Public Property FunctionVertical() As PeriodicDesignation
        Get
            Return vertfxn
        End Get
        Set(ByVal Value As PeriodicDesignation)
            vertfxn = Value
        End Set
    End Property
    Public Property RadispeedX() As Integer
        Get
            Return xrspeed
        End Get
        Set(ByVal Value As Integer)
            xrspeed = Value
        End Set
    End Property
    Public Property RadispeedY() As Integer
        Get
            Return yrspeed
        End Get
        Set(ByVal Value As Integer)
            yrspeed = Value
        End Set
    End Property
    Public Property FrequencyX() As Integer
        Get
            Return xfreq
        End Get
        Set(ByVal Value As Integer)
            xfreq = Value
        End Set
    End Property
    Public Property FrequencyY() As Integer
        Get
            Return yfreq
        End Get
        Set(ByVal Value As Integer)
            yfreq = Value
        End Set
    End Property
    Public Sub New(ByVal R As Rectangle, ByVal RadispdX As Integer, ByVal RadispdY As Integer, ByVal FreqX As Integer, ByVal FreqY As Integer, ByVal HFxn As PeriodicDesignation, ByVal VFxn As PeriodicDesignation)
        Me.horizfxn = HFxn
        Me.rect = R
        Debug.WriteLine(R.Width.ToString())
        Me.vertfxn = VFxn
        Me.xfreq = FreqX
        Me.xrspeed = RadispdX
        Me.yfreq = FreqY
        Me.yrspeed = RadispdY

    End Sub

    Public Sub Offset(ByVal dX As Integer, ByVal dY As Integer)
        rect.Offset(dX, dY)
    End Sub

End Structure
